Loading...
Searching...
No Matches
BALL::AmiraMeshFile Class Reference
Molecular Modeling » File Formats

`#include <BALL/FORMAT/amiraMeshFile.h>`

Inheritance diagram for BALL::AmiraMeshFile:

## Public Member Functions

Constructors and Destructor
| AmiraMeshFile ()
| Default constructor.
| AmiraMeshFile (const String &name, File::OpenMode open_mode=std::ios::in)
virtual | ~AmiraMeshFile ()
| Destructor.
Assignment
virtual void | clear ()
| Clear method.
Predicates
bool | operator== (const AmiraMeshFile &file) const
| Equality operator.
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Public methods for file handling

bool | binary_
| flag indicating whether a ascii or binary data section
Vector3 | extent_
| the extent of the map
Vector3 | min_
| Vector representing the first point of the maps bounding box.
Vector3 | max_
| Vector representing the second point of the maps bounding box.
long | idx_start_data_
Position | num_components_
virtual bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
virtual bool | readHeader ()
virtual bool | read (RegularData3D &map)
virtual bool | writeHeader ()
virtual bool | write (RegularData3D &map)
const char * | findAndJump_ (const char *buffer, const char *search_String)

## Additional Inherited Members

Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)
Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

AmiraMesh grid file format. This class enables BALL to read the native format of Amira. The academic version of Amira is developed by the Visualization and Data Analysis Group at Zuse Institute Berlin. Commercial versions are available from Visage Imaging, Berlin and VSG - Visualization Sciences Group, France.

For detailed information on the file format see: http://amira.zib.de/mol/usersguide/HxFileFormat_AmiraMesh.html

At the moment, we only support uniform grids in little endian binary and ASCII data sections. The following parser code is inspired by the code of Tino Weinkauf (cf. http://www.mpi-inf.mpg.de/~weinkauf/notes/amiramesh.html)

Definition at line 35 of file amiraMeshFile.h.

## Constructor & Destructor Documentation

## AmiraMeshFile() [1/2]

BALL::AmiraMeshFile::AmiraMeshFile | ( |  | ) |

Default constructor.

## AmiraMeshFile() [2/2]

BALL::AmiraMeshFile::AmiraMeshFile | ( | const String & | name,
|  | File::OpenMode | open_mode = std::ios::in )

Detailed constructor

Exceptions

  Exception::FileNotFound | if the file could not be opened

## ~AmiraMeshFile()

virtual BALL::AmiraMeshFile::~AmiraMeshFile | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## clear()

virtual void BALL::AmiraMeshFile::clear | ( |  | ) |

virtual

Clear method.

Reimplemented from BALL::File.

## findAndJump_()

const char * BALL::AmiraMeshFile::findAndJump_ | ( | const char * | buffer,
|  | const char * | search_String )

protected

Find string in given buffer and return a pointer to the contents directly behind the SearchString

## open()

virtual bool BALL::AmiraMeshFile::open | ( | const String & | name,
|  | File::OpenMode | open_mode = std::ios::in )

virtual

open a AmiraMeshFile

Exceptions

  Exception::FileNotFound | if the file could not be opened

## operator==()

bool BALL::AmiraMeshFile::operator== | ( | const AmiraMeshFile & | file | ) | const

Equality operator.

## read()

virtual bool BALL::AmiraMeshFile::read | ( | RegularData3D & | map | ) |

virtual

Read the file into a RegularData3D field.

## readHeader()

virtual bool BALL::AmiraMeshFile::readHeader | ( |  | ) |

virtual

Read the header of an existing file. Return true if the header could be read successfully, false ow.

## write()

virtual bool BALL::AmiraMeshFile::write | ( | RegularData3D & | map | ) |

virtual

Write a RegularData3D to a AmiraMesh File Return true if the map could be written successfully, false ow.

## writeHeader()

virtual bool BALL::AmiraMeshFile::writeHeader | ( |  | ) |

virtual

Write a header Return true if the header could be written successfully, false ow.

## Member Data Documentation

## binary_

bool BALL::AmiraMeshFile::binary_

protected

flag indicating whether a ascii or binary data section

Definition at line 110 of file amiraMeshFile.h.

## extent_

Vector3 BALL::AmiraMeshFile::extent_

protected

the extent of the map

Definition at line 113 of file amiraMeshFile.h.

## idx_start_data_

long BALL::AmiraMeshFile::idx_start_data_

protected

Definition at line 122 of file amiraMeshFile.h.

## max_

Vector3 BALL::AmiraMeshFile::max_

protected

Vector representing the second point of the maps bounding box.

Definition at line 119 of file amiraMeshFile.h.

## min_

Vector3 BALL::AmiraMeshFile::min_

protected

Vector representing the first point of the maps bounding box.

Definition at line 116 of file amiraMeshFile.h.

## num_components_

Position BALL::AmiraMeshFile::num_components_

protected

Definition at line 125 of file amiraMeshFile.h.